SystemOrganization addCategory: #'O-ST-Core'!
SystemOrganization addCategory: #'O-ST-Core-Reflection'!

!OstIdentityDictionary methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstIdentityDictionary methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstSortedCollection methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstSortedCollection methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGFannkuchRedux methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGFannkuchRedux methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGBinaryTrees methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGBinaryTrees methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGRepeatStream methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGRepeatStream methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!RBMethodNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/3/2011 22:26'!
sourceText
	^source! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'lr 8/28/2010 11:10'!
compilerClass
	"Answer the compiler class responsible for compiling the methods of this class. Be extremely careful as this method might be called before everything is properly setup."
	
	| class |
	class := Smalltalk
		at: #RBCompilerDispatcher
		ifAbsent: [ ^ Compiler ].
	(class respondsTo: #current)
		ifFalse: [ ^ Compiler ].
	(class current isNil)
		ifTrue: [ ^ Compiler ].
	^ class! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'lr 8/28/2010 10:54'!
evaluatorClass
	^ self compilerClass! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/15/2013 13:27'!
flushOmniMethods
	| copy |
	self localSelectors do: [: each |
		each isOmniSelector ifTrue: [ self removeSelector: each ]]. 
	
	"
	self methodDictionary keysDo: [ :each |
		each isOmniSelector ifTrue: [
			copy := copy ifNil: [ self methodDictionary copy ].
			copy removeDangerouslyKey: each ifAbsent: [] ] ].
	copy ifNotNil: [ self methodDictionary become: copy ]"! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/18/2012 22:01'!
omniBasicNew
	| obj |
	<omniUnenforced>
	obj := self basicNew.
	OstDomain initializeDomainForNewObject: obj of: self.
	^ obj! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/18/2012 22:01'!
omniBasicNew: sizeRequested 
	"This is the omni-fied implementation.
	 The original basicNew: is now rawBasicNew:."
	<omniUnenforced>
	
	| obj |
	obj := self basicNew: sizeRequested.
	OstDomain initializeDomainForNewObject: obj of: self.
	^ obj! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/3/2013 23:20'!
omniDomain
	"We consider these classes, i.e., their objects, metaobjects so that their are not owned by
	 any specific domain."
	<omniUnenforced>
	^ nil! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/9/2011 17:08'!
omniMethods
	^ Array streamContents: [ :stream |
		self methodDictionary keysAndValuesDo: [ :key :value |
			key isOmniSelector 
				ifTrue: [ stream nextPut: value ] ] ]! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/9/2011 17:05'!
selectors
	"Answer a Set of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys reject: [ :each | each isOmniSelector ]! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/9/2011 17:05'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isOmniSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!Behavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/9/2011 17:05'!
selectorsDo: selectorBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysDo: [ :selector |
		selector isOmniSelector 
			ifFalse: [ selectorBlock value: selector ] ]! !

RBSemanticAnnotator subclass: #OstTransformer
	instanceVariableNames: 'doFullTransformation doLocalTransformation numOfOmniTemps'
	classVariableNames: 'ReadSelector RequestExecutionSelectors RequestSuperExecutionSelectors WriteSelector'
	poolDictionaries: ''
	category: 'O-ST-Core'!

!OstTransformer commentStamp: '<historical>' prior: 0!
OmniTransformer iterates over the AST of a method to transform it.
The goal is to delegate all read, write, and message-send operations via a domain object.!

!OstTransformer class methodsFor: 'initialization' stamp: 'StefanMarr 3/20/2012 17:48'!
generateRequestExecutionSelectors
	| sel max |
	max := 15.
	sel := #requestExecutionOf:.
	RequestExecutionSelectors := Array new: max.
	1 to: max do: [:i |
		RequestExecutionSelectors at: i put: sel.
		sel := (sel, #with:) asSymbol.
	].

	sel := #requestExecutionOf:lookup:.
	RequestSuperExecutionSelectors := Array new: max.
	1 to: max do: [:i |
		RequestSuperExecutionSelectors at: i put: sel.
		sel := (sel, #with:) asSymbol.
	].! !

!OstTransformer class methodsFor: 'initialization' stamp: 'StefanMarr 6/12/2013 00:16'!
initializeForTarget: nooptOrIsolate
	"
	  self initializeForTarget: #NoOpt. 
	  self initializeForTarget: #Isolate.
	"

	nooptOrIsolate = #NoOpt ifTrue: [
		ReadSelector  := #readLiteral:.
		WriteSelector := #write:toLiteral:].
	
	nooptOrIsolate = #Isolate ifTrue: [
		ReadSelector  := #internal_readLiteral:.
		WriteSelector := #internal_write:toLiteral:].! !

!OstTransformer class methodsFor: 'initialization' stamp: 'StefanMarr 6/11/2013 16:36'!
initializeOST
	self generateRequestExecutionSelectors.! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 12/7/2011 20:49'!
acceptAssignmentNode: anAssignmentNode
	super acceptAssignmentNode: anAssignmentNode.
	
	self doTransformation ifFalse: [^self].
	
	(anAssignmentNode variable isInstanceBinding or:
	[anAssignmentNode variable isLiteralBinding "or: REMOTE NOT YET SUPPORTED
	[anAssignmentNode variable isRemote]"]) ifTrue: [
		| replacement |
		replacement := self createOmniAssignment: anAssignmentNode.
		anAssignmentNode parent replaceNode: anAssignmentNode withNode: replacement.
	]! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 12/8/2011 15:39'!
acceptMessageNode: aMessageNode
	| doLocalTransformationOld replacement |
	doLocalTransformationOld := doLocalTransformation.
	
	doLocalTransformation := doLocalTransformation or: [self isOmniEntryMessage: aMessageNode selector].

	(self doTransformation and: [aMessageNode isInlined not])
		ifTrue:  [self  transformMessageNode: aMessageNode.]
		ifFalse: [super acceptMessageNode:    aMessageNode.].

	doLocalTransformation := doLocalTransformationOld.! !

!OstTransformer methodsFor: 'visitor-dispatching' stamp: 'StefanMarr 12/7/2011 20:55'!
acceptMethodNode: aMethodNode
	super acceptMethodNode: aMethodNode.
	doFullTransformation ifTrue: [
		aMethodNode selector: (aMethodNode selector asOmniSelector)
	].! !

!OstTransformer methodsFor: 'initialize-release' stamp: 'StefanMarr 1/2/2012 18:38'!
acceptOmniEntryNode: aMessageNode
	(self omniEntryBlockIsReceiver: aMessageNode selector)
		ifTrue: [
			"Then we do not do a full processing, but are skipping the arguments"
			(aMessageNode isCascaded not or: [aMessageNode isFirstCascaded]) 
					ifTrue: [self visitNode: aMessageNode receiver].]
		ifFalse:[
			"If the block to be omnified is the argument however, we do transform it."
			aMessageNode arguments do: [:each | self visitNode: each]]! !

!OstTransformer methodsFor: 'visitor-dispatching' stamp: 'StefanMarr 12/8/2011 00:56'!
acceptVariableNode: aVariableNode
	| replacement |
	self doTransformation ifFalse: [^self].
	
	super acceptVariableNode: aVariableNode.
	
	"Not every variable node we are going to encounter is a read.
	 Make sure it is not the variable node of a parent assignment node.
	 Furthermore, we do not need to take care of temp assignments.
	 Only globals, instances, and perhaps remote onces of a closure."
	(aVariableNode isRead
	 and: [aVariableNode isLiteralBinding   or: 
		   [aVariableNode isInstanceBinding "or: REMOTES NOT SUPPORTED at the moment
			[aVariableNode isRemote]"]])
		ifFalse: [^self].
	
	"Now we are sure that we have to transform a variable read".
	replacement := self createOmniReadNode: aVariableNode.
	aVariableNode parent replaceNode: aVariableNode withNode: replacement. 
! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 8/2/2012 11:18'!
applyTransformations: methodNode inScopeOf: aClass
	"We have two cases:
	   Either it is a normal method, and we do only the omni blocks,
	   or it is a fully omni method and we transform everything.
	
	 doFullTransformation indicates that we do not only local adaptations.
	"
	| classScope |
	(self pragmasForbidTransformation: methodNode)
		ifTrue: [^self].
	(self pragmasForbidFullTransformation: methodNode)
		ifTrue: [doFullTransformation := false].
	
	classScope := RBVariableScope
							owner: (RBLiteralScope 	owner: RBRootScope new class: aClass)
							class: aClass.
	
	self start: methodNode scope: classScope.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/29/2013 21:03'!
createObtainCurrentOmniDomainNode
	| msgSendNode  |
	msgSendNode := RBMessageNode
						  receiver: (RBMessageNode receiver: (RBLiteralValueNode value: Processor)
						                         selector: #activeProcess)
						  selector: #omniDomain.
	msgSendNode beOmniNode.
	^ msgSendNode.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 7/21/2012 18:51'!
createObtainSelfOmniDomainNode
	| msgSendNode  |
	msgSendNode := RBMessageNode receiver: self createSelfRefNode
									   selector: #omniDomain.
	msgSendNode beOmniNode.
	^ msgSendNode.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 7/18/2012 21:47'!
createOmniAssignment: anAssignmentNode
	| var |
	var := anAssignmentNode variable.
	var isInstanceBinding ifTrue: [
		^ self createWriteMessageSendFor: var with: anAssignmentNode value.
	]
	ifFalse: [
		| globalAssoc sendArgs |
		var isLiteralBinding ifFalse: [self halt: 'I guess we still need to implement something, e.g., remote vars.'].
		
		^ self createWriteGlobalMessageSendFor: var with: anAssignmentNode value.
	].! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 7/21/2012 18:52'!
createOmniDomainRefNode
	"Return a node that will resolve at runtime to the omni domain object,
	 or in case the class does not have a slot called omniDomain, resolve to
	 the nil object"
	| omniIdx omniRef |
	omniIdx := OstDomain domainIndexFromClass: scope theClass.
	omniIdx = 0
		ifTrue: [
			"The class does not have a omniDomain slot"
			"What to do now?
			 For the moment, we will do `self omniDomain`"
			omniRef := self createObtainSelfOmniDomainNode.
		]
		ifFalse:[
			"This class got a omniDomain slot"
			omniRef := RBVariableNode named: #omniDomain.
			omniRef variableBinding: (scope lookup: #omniDomain).
		].
	
	^ omniRef! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/15/2011 14:25'!
createOmniMessageNode: aMessageNode
	| omniSel |

	omniSel := aMessageNode selector asOmniSelector.
	
	^ self createRequestExecutionNodeOn: aMessageNode receiver
										 with: omniSel
										  and: aMessageNode arguments.
! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/9/2011 15:50'!
createOmniReadNode: aVariableNode
	| selfRef omniDomainRef instIdx sendArgs |
	
	aVariableNode isInstanceBinding ifTrue: [
		^ self createReadMessageSendFor: aVariableNode.
	]
	ifFalse: [
		aVariableNode isLiteralBinding
			ifFalse: [self halt: 'I guess we still need to implement something, e.g., remote vars.'].
		^ self createReadGlobalMessageSendFor: aVariableNode.
	].
	! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 6/8/2013 19:21'!
createReadGlobalMessageSendFor: aVariableNode
	| globalAssoc args sendNode |

	globalAssoc := RBLiteralValueNode value: aVariableNode variableBinding binding.
		
	args := OrderedCollection new: 1.
	args add: globalAssoc.
		
	sendNode := RBMessageNode receiver: self createObtainCurrentOmniDomainNode
		                          selector: ReadSelector
		                          arguments: args.
	sendNode beOmniNode.
	^ sendNode! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/8/2011 01:21'!
createReadMessageSendFor: aVariableNode
	| selfRef omniDomainRef instIdx sendArgs readNode |
	selfRef := self createSelfRefNode.
	omniDomainRef := self createOmniDomainRefNode.
	
	instIdx  := RBLiteralValueNode value: (aVariableNode variableBinding index).
	sendArgs := OrderedCollection new: 2.
	sendArgs add: instIdx.
	sendArgs add: selfRef.
	readNode := RBMessageNode receiver: omniDomainRef selector: #readField:of: arguments: sendArgs.
	readNode beOmniNode.
	^ readNode
! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 3/20/2012 17:38'!
createRequestExecutionNodeOn: receiver with: selector and: arguments
	| msgSendNode reqExecSelector msgArguments numArgs isSuperSend newRcvr |
	
	"REM: we send to self, to avoid more complex rewrites
	  #requestExecutionOf:with:...   or   #requestExecutionOf:lookup:with:..."
	numArgs := selector numArgs.

	isSuperSend := receiver isVariable
						ifTrue:  [receiver variableBinding isSuperBinding]
						ifFalse: [false].
	newRcvr := isSuperSend ifTrue: [self createSelfRefNode]
								ifFalse:[receiver].

	reqExecSelector := self requestExecutionSelectorFor: numArgs withSuper: isSuperSend.
	
	"One extra argument for the class where the lookup starts."
	isSuperSend ifTrue: [ numArgs := numArgs + 1. ].
	
	"And another argument for the selector"
	numArgs := numArgs + 1.
	
	msgArguments := OrderedCollection new: numArgs.
	msgArguments add: (RBLiteralValueNode value: selector).
	isSuperSend ifTrue: [
		msgArguments add: (RBLiteralValueNode value: scope theClass superclass).
	].
	msgArguments addAll: arguments.
	
	msgSendNode := RBMessageNode receiver:  newRcvr
								      selector:  reqExecSelector
								      arguments: msgArguments.
	msgSendNode beOmniNode.
	^ msgSendNode! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/8/2011 01:11'!
createSelfRefNode
	| selfRef |
	selfRef := RBVariableNode named: 'self'.
	selfRef variableBinding: (scope lookup: 'self').
	^ selfRef! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 6/8/2013 19:21'!
createWriteGlobalMessageSendFor: aVariableNode with: valueNode
	| globalAssoc args sendNode |

	globalAssoc := RBLiteralValueNode value: aVariableNode variableBinding binding.
		
	args := OrderedCollection new: 2.
	args add: valueNode.
	args add: globalAssoc.
		
	sendNode := RBMessageNode receiver: self createObtainCurrentOmniDomainNode
		                          selector:  WriteSelector
		                          arguments: args.
	sendNode beOmniNode.
	^ sendNode! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/8/2011 21:57'!
createWriteMessageSendFor: aVarNode with: aValue
		| selfRef omniDomainRef instIdx sendArgs sendNode |
		selfRef := self createSelfRefNode.
		omniDomainRef := self createOmniDomainRefNode.
		
		instIdx := RBLiteralValueNode value: (aVarNode variableBinding index).
		
		sendArgs := OrderedCollection new: 3.
		sendArgs add: aValue.
		sendArgs add: instIdx.
		sendArgs add: selfRef.
		
		sendNode := RBMessageNode receiver: omniDomainRef
									   selector: #write:toField:of:
									   arguments: sendArgs.
		sendNode beOmniNode.
		^ sendNode
! !

!OstTransformer methodsFor: 'testing' stamp: 'StefanMarr 12/7/2011 20:35'!
doTransformation
	^ doFullTransformation or: [doLocalTransformation]! !

!OstTransformer methodsFor: 'accessing' stamp: 'StefanMarr 12/7/2011 20:35'!
fullTransformation: aBool
	doFullTransformation := aBool! !

!OstTransformer methodsFor: 'initialize-release' stamp: 'StefanMarr 6/8/2013 19:15'!
initialize
	super initialize.
	doFullTransformation  := false.
	doLocalTransformation := false.
	numOfOmniTemps := 0.
	
	ReadSelector ifNil: [Error signal: 'See class-side to initalize transformer and set the desired target platform.']
! !

!OstTransformer methodsFor: 'visitor-double dispatching' stamp: 'StefanMarr 1/3/2012 11:22'!
isOmniEntryMessage: aSelector
	^ aSelector = #omni            or: [
	  aSelector = #omni:           or: [
	  aSelector = #atomic          or: [
	  aSelector = #evaluateAsync:  or: [
	  aSelector = #newWithInitializer:
	]]]].! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 12/9/2011 15:29'!
nextOmniTempIdx
	"Creates a sequence of unique id numbers for a method transformation to name the temporary variables"
	numOfOmniTemps := numOfOmniTemps + 1.
	^ numOfOmniTemps! !

!OstTransformer methodsFor: 'initialize-release' stamp: 'StefanMarr 1/3/2012 11:21'!
omniEntryBlockIsReceiver: aSelector
	(aSelector = #omni            or: [
	 aSelector = #omni:           or: [
	 aSelector = #atomic]])
		ifTrue: [^true].
		
	(aSelector = #evaluateAsync:  or: [
	 aSelector = #newWithInitializer:])
		ifTrue: [^ false].
	

	"Else"
	'This selector is not currently known' halt.! !

!OstTransformer methodsFor: 'testing' stamp: 'StefanMarr 8/2/2012 11:18'!
pragmasForbidFullTransformation: methodNode
	"The #omniUnenforced pragma forbids full transformation, but allows partial transformation"
	
	methodNode pragmas do: [:each |
		(#omniUnenforced = each selector)
			ifTrue: [^true].
	].
	^false.! !

!OstTransformer methodsFor: 'testing' stamp: 'StefanMarr 8/2/2012 11:18'!
pragmasForbidTransformation: methodNode
	"Some of our pragmas restrict the boundaries of the Omni execution layer.
	 They enable to break out into the implementation level."
	methodNode pragmas do: [:each |
		(#omniReplacement: = each selector)
			ifTrue: [^true].
	].
	^false.! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 1/2/2012 18:07'!
requestExecutionSelectorFor: nArgs withSuper: superSend
	(nArgs >= 0 and: [nArgs < RequestSuperExecutionSelectors size])
		ifTrue: [
			superSend
				ifTrue: [^ RequestSuperExecutionSelectors at: nArgs + 1.]
				ifFalse:[^ RequestExecutionSelectors at: nArgs + 1.]
		]
		ifFalse: [
			self halt: 'This is currently not implemented!! ',
			           'Need either to extend this table/array, ',
			           'or make a distinction to use the other primitive (84) which accepts an array.'.
		].
	^ nil! !

!OstTransformer methodsFor: 'transformation' stamp: 'StefanMarr 7/15/2013 11:29'!
transformMessageNode: aMessageNode
	(doFullTransformation or: [(self isOmniEntryMessage: aMessageNode selector) not])
		ifTrue: [ super acceptMessageNode: aMessageNode. ]
		ifFalse:[
			"This is the case if it is the omni entry node."
			self acceptOmniEntryNode: aMessageNode.
		].

	((self isOmniEntryMessage: aMessageNode selector) or: [
	 aMessageNode isInlined or: [
	 aMessageNode isOmniNode or: [
	 aMessageNode receiver isLiteral and: [aMessageNode arguments size = 0] ]]]) "REM: added optimization for literal nodes here, we do not omnify those if they don't take parameters"
		ifFalse: [
			| replacement |
			replacement := self createOmniMessageNode: aMessageNode.
			aMessageNode parent replaceNode: aMessageNode withNode: replacement.
		].! !

!OstBGRandomNumber methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGRandomNumber methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!RBMessageNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/8/2011 00:02'!
beOmniNode
	isOmniNode := true.! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'JorgeRessia 11/25/2009 13:33'!
isInlineAndOr
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(self selectorParts allSatisfy: [ :each | #(and: or:) includes: each value ]) 
		ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each isBlock ])  ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each arguments isEmpty ])
			ifFalse: [
				self notify: 'and: (or:) takes zero-arg block'.
				^ false ].
	^ true! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineCase

	self isCascaded ifTrue: [^ false].
	(#(caseOf: caseOf:otherwise:) includes: self selector) ifFalse: [^ false].
	self arguments size = 2 ifTrue: [  "otherwise block"
		self arguments last isBlock ifFalse: [^ false]].
	self arguments first isArray ifFalse: [^ false].
	self arguments first statements do: [:assoc |
		(assoc isMessage and: [assoc selector == #->]) ifFalse: [^ false].
		assoc receiver isBlock ifFalse: [^ false].
		assoc receiver arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'. ^ false].
		assoc arguments first isBlock ifFalse: [^ false].
		assoc arguments first arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'].
	].
	^ true! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineIf

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	self arguments do: [:block |
		block arguments isEmpty ifFalse: [
			self notify: 'ifTrue:ifFalse: takes zero-arg blocks'.
			^ false
		]
	].
	^ true! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'MarcusDenker 8/21/2010 13:40'!
isInlineIfNil

	| assertNone assertOneOrNone |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifNil: ifNotNil: ifNil:ifNotNil: ifNotNil:ifNil:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	assertNone := [:block | 
		block arguments isEmpty ifFalse: [self notify: 'ifNil: takes zero-arg block'. ^ false]
	].
	assertOneOrNone := [:block | 
		block arguments size > 1 ifTrue: [self notify: 'ifNotNil: takes zero- or one-arg block'. ^ false]
	].
	self selector caseOf: {
		[#ifNil:] 		 	-> [assertNone value: self arguments first].
		[#ifNil:ifNotNil:] 	-> [assertNone value: self arguments first. 
							   assertOneOrNone value: self arguments last].
		[#ifNotNil:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNilDo:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNil:ifNil:] 	-> [assertOneOrNone value: self arguments first. 
							   assertNone value: self arguments last]
	}.
	^ true! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'MarcusDenker 9/3/2010 15:03'!
isInlineToDo

	| block step |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(to:do: to:by:do:) includes: self selector) ifFalse: [^ false].
	self arguments first isBlock ifTrue: [^ false].
	block := self arguments last.
	block isBlock ifFalse: [^ false].
	block arguments size = 1 ifFalse: [
		self notify: 'to:do: block must take one arg'. ^ false].
	(RBParseTreeSearcher new
		matches: block arguments first name , ' := `@object' do: [:n :a | true];
		executeTree: block initialAnswer: false) ifTrue: [^ false].
	self arguments size = 3 "to:by:do:" ifTrue: [
		step := self arguments second.
		step isLiteral ifFalse: [^ false].
		step value = 0 ifTrue: [self notify: 'by: step can''t be zero'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineWhile

	self isCascaded ifTrue: [^ false].
	(#(whileFalse: whileTrue: whileFalse whileTrue) includes: self selector) ifFalse: [^ false].
	self receiver isBlock ifFalse: [^ false].
	self receiver arguments isEmpty ifFalse: [self notify: 'while receiver block must have no arguments'. ^ false].
	self arguments isEmpty ifFalse: [
		self arguments first isBlock ifFalse: [^ false].
		self arguments first arguments isEmpty ifFalse: [self notify: 'while takes a zero-arg block as its argument'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*O-ST-Core-inline' stamp: 'StefanMarr 12/3/2011 14:22'!
isInlined
	^ self isInlineAndOr or:
	 [self isInlineCase  or:
	 [self isInlineIf    or:
	 [self isInlineIfNil or:
	 [self isInlineToDo  or:
	  self isInlineWhile    ]]]]! !

!RBMessageNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/8/2011 00:06'!
isOmniNode
	^ isOmniNode = true "with this, we do not need to change initialize"! !

!OstAssociation methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstAssociation methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGPiDigitSpigot methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGPiDigitSpigot methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!UndefinedObject methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ nil! !

!UndefinedObject methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/22/2012 02:25'!
omniDomain: aDomain
	^ nil! !

!HashTableSizes methodsFor: '*O-ST-Core' stamp: 'StefanMarr 4/30/2013 13:36'!
omniDomain
	"we consider it an immutable object"
	<omniUnenforced>
	^ nil! !

!RBCompilerDispatcher classSide methodsFor: '*O-ST-Core' stamp: 'StefanMarr 1/13/2013 17:00'!
couldEvaluate: anObject
	"Answer true if anObject can be passed to my various #evaluate: methods."
	^anObject isString or: [ anObject isText or: [ anObject isStream ]]! !

!String methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/8/2011 21:56'!
numArgs 
	"Answer either the number of arguments that the receiver would take if considered a selector.  Answer -1 if it couldn't be a selector. It is intended mostly for the assistance of spelling correction."

	| firstChar numColons start ix |
	self size = 0 ifTrue: [^ -1].
	self isOmniSelector 
		ifTrue: [ ^ self asNormalSelector numArgs ].
	firstChar := self at: 1.
	(firstChar isLetter or: [ firstChar = $_]) ifTrue:
		["Fast reject if any chars are non-alphanumeric
		NOTE: fast only for Byte things - Broken for Wide"
		self class isBytes
			ifTrue: [(self findSubstring: '~' in: self startingAt: 1 matchTable: Tokenish) > 0 ifTrue: [^ -1]]
			ifFalse: [2 to: self size do: [:i | (self at: i) tokenish ifFalse: [^ -1]]].
		"Fast colon count"
		numColons := 0.  start := 1.
		[(ix := self indexOf: $: startingAt: start) > 0]
			whileTrue:
				[ix = start ifTrue: [^-1].
				numColons := numColons + 1.
				start := ix + 1].
		numColons = 0 ifTrue: [^ 0].
		self last = $:
			ifTrue: [^ numColons]
			ifFalse: [^ -1]].
	firstChar isSpecial ifTrue:
		[self size = 1 ifTrue: [^ 1].
		2 to: self size do: [:i | (self at: i) isSpecial ifFalse: [^ -1]].
		^ 1].
	^ -1.! !

!OstInterval methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstInterval methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!BlockClosure methodsFor: '*O-ST-Core' stamp: 'StefanMarr 4/28/2013 22:51'!
omniDomain
	"we treat them as immutable metaobjects..."
	<omniUnenforced>
	^ nil! !

RBCompiler subclass: #OstCompiler
	instanceVariableNames: 'doFullTransformation'
	classVariableNames: 'ErrorOnMissingOmniMethod OldCompiler'
	poolDictionaries: ''
	category: 'O-ST-Core'!

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 12/15/2011 14:13'!
disableCompiler
	OldCompiler = self ifTrue: [
		RBCompilerDispatcher current: RBCompiler.
	].
	RBCompilerDispatcher current: OldCompiler.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 9/12/2012 13:45'!
disableErrorOnMissingOmnifiedMethod
	ErrorOnMissingOmniMethod := false.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 12/12/2011 00:52'!
enableCompiler
	| old |
	old := RBCompilerDispatcher current.
	
	"Remember old compiler only if it is not our own."
	old ~= self ifTrue: [
		OldCompiler := old].
	
	RBCompilerDispatcher current: self.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 5/15/2013 15:54'!
errorOnMissingOmnifiedMethod
	" self errorOnMissingOmnifiedMethod "
	ErrorOnMissingOmniMethod := true.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 12/8/2011 14:54'!
flushAllOmniMethods
	Smalltalk allClassesAndTraits 
		do: [ :ea | ea flushOmniMethods. ea class flushOmniMethods ]
		displayingProgress: 'Flushing Omnified Methods'.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 6/11/2013 16:39'!
initializeOST
	self enableCompiler.
	self registerChangeListener.
	
	(RBMessageNode hasInstVarNamed: #isOmniNode) ifFalse: [
		RBMessageNode addInstVarNamed: #isOmniNode.
	].

	ErrorOnMissingOmniMethod := false.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 7/15/2013 13:14'!
installOmniVersionOf: selector in: class
	"Answer the atomic counterpart of aCompiledMethod.
	Methods with the pragma #omniUnenforced are considered to be already omnified.
	Methods with the pragma #omni: will use the annotation code for the omnified counterpart."
	<omniUnenforced>
	| omniCM omniName compiledMethod |

	"Is already atomic do nothing"
	selector isOmniSelector ifTrue: [
		^ class lookupSelector: selector ].

	omniName := selector asOmniSelector.
	compiledMethod := class lookupSelector: selector.
		
	"These pragmas are specified in OstTransformer>>isOmniTransformationPragma:"
	compiledMethod pragmas do: [ :each |
		each keyword = #omniUnenforced
			ifTrue: [ self installOrExchange: compiledMethod in: class for: omniName.
				^ compiledMethod ].
			
		each keyword = #omniReplacement:
			ifTrue: [
				| replacementName replacementMeth |
				replacementName := each arguments first.
				((replacementName beginsWith: #omni) or: [replacementName beginsWith: #atomic]) ifFalse: [
					replacementName := (#omni, replacementName) asSymbol].
				
				replacementMeth := class lookupSelector: replacementName.
				omniCM := self installOmniVersionOf: replacementName in: replacementMeth methodClass.
				self installOrExchange: omniCM in: class for: omniName.
				^ compiledMethod
			].
	].

	omniCM := self recompileOmnified: compiledMethod.
	
	self installOrExchange: omniCM in: class for: omniName.
	^ omniCM! !

!OstCompiler class methodsFor: 'helper' stamp: 'StefanMarr 7/15/2013 14:18'!
installOrExchange: compiledMethod in: class for: aSelector
	(class includesLocalSelector: aSelector)
		ifFalse: [ self registerLocalSelector: aSelector ].
	
	class methodDict at: aSelector put: compiledMethod.
	
	aSelector flushCache.
	compiledMethod flushCache.
	^ compiledMethod! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 7/15/2013 13:43'!
omniMethod: aMessage missing: aReceiver in: aClass
	"This method is called whenever a missing atomic method is called. Installs a whole hierarchy of atomic methods."
	<omniUnenforced>
	
	| selector addedAtomicMethod curClass |
	selector := aMessage selector asNormalSelector.
	
	ErrorOnMissingOmniMethod ifTrue: [
		^ (MessageNotUnderstood new
				message: aMessage;
				receiver: aReceiver;
				signal)].
	
	(ProtoObject withAllSubclasses select: [:c | c includesSelector: selector])
		do: [ :class |
			self installOmniVersionOf: selector in: class
			"[1 ifError: [:err :rcvr| Transcript cr; show: 'Error while handling a missing omni method. ',
									selector, ' did not compile properly for ', class asString,
									'. Compilation resulted in the following error: ',
									err].]."
		]
	displayingProgress: 'Omnify Methods: ', selector.
! !

!OstCompiler class methodsFor: 'events' stamp: 'StefanMarr 7/18/2012 22:02'!
onMethodModified: anObject
	<omniUnenforced>

	"Ignore the already omnified methods"
	anObject itemSelector isOmniSelector
		ifTrue: [^self].
	
	"Also blacklist a few things"
	((anObject itemClass = Debugger)
	or: [anObject itemClass = Decompiler])
		ifTrue: [^ self].

	"For the rest we do the atomic stuff"	
	self installOmniVersionOf: anObject itemSelector in:  anObject itemClass.! !

!OstCompiler class methodsFor: 'events' stamp: 'StefanMarr 7/18/2012 22:02'!
onMethodRemoved: anObject
	<omniUnenforced>
	
	anObject itemClass methodDict 
		removeKey: anObject itemSelector 
			asOmniSelector
		ifAbsent: nil! !

!OstCompiler class methodsFor: 'compiling' stamp: 'StefanMarr 7/18/2012 22:04'!
recompile: aCompiledMethod
	"Recompile the given method normally"
	<omniUnenforced>
	
	| compiler |
	compiler := self new.
	^ compiler recompile: aCompiledMethod.! !

!OstCompiler class methodsFor: 'compiling' stamp: 'StefanMarr 7/18/2012 22:04'!
recompileOmnified: aCompiledMethod
	"Recompile the given method normally"
	<omniUnenforced>
	
	| compiler |
	compiler := self new.
	^ compiler recompileOmnified: aCompiledMethod.! !

!OstCompiler class methodsFor: 'compiler support' stamp: 'StefanMarr 6/11/2013 16:58'!
recompileSystemWithOstCompiler
	<omniUnenforced>
	
	self enableCompiler.
	self flushAllOmniMethods.

	(#(AmbientTalkST O LRSTM ClojureST CL) gather: [:pkg |
		(PackageInfo named: pkg) classes ])
			do: [:c | c compileAll]
			displayingProgress: 'Recompiling with OstCompiler support enabled'.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/8/2011 14:40'!
registerChangeListener

	SystemChangeNotifier uniqueInstance
		"Currently I only do lazy compilation on first use for new stuff"
		"notify: self ofSystemChangesOfItem: #method change: #Added using: #onMethodAdded:;"
		
		"For existing stuff, however, we need to ensure consistency"
		notify: self ofSystemChangesOfItem: #method change: #Modified using: #onMethodModified:;
		notify: self ofSystemChangesOfItem: #method change: #Removed using: #onMethodRemoved:.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 6/11/2013 16:39'!
unloadOST
	self flushAllOmniMethods.
	
	RBMessageNode removeInstVarNamed: #isOmniNode.! !

!OstCompiler class methodsFor: 'class initialization' stamp: 'StefanMarr 12/7/2011 22:11'!
unregisterChangeListener

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self.! !

!OstCompiler methodsFor: 'compiler' stamp: 'StefanMarr 6/4/2013 16:45'!
compileNoPattern: aTextOrStream in: aClass context: aContext notifying: aRequestor ifFail: aFailBlock
	self setSource: aTextOrStream; setContext: aContext; setRequestor: aRequestor; setFailBlock: [ ^ aFailBlock value ].
	self setClass: (aContext isNil ifTrue: [ aClass ] ifFalse: [ aContext receiver ]) class.
	^ self handler: [ self translate: (self parse: false) ].! !

!OstCompiler methodsFor: 'initialize-release' stamp: 'StefanMarr 12/7/2011 22:11'!
initialize
	super initialize.
	doFullTransformation := false.! !

!OstCompiler methodsFor: 'errors' stamp: 'StefanMarr 9/6/2012 20:49'!
notify: aString at: anInteger in: aSource
	Halt once.
	SyntaxErrorNotification
				inClass: class
				category: category
				withCode: (aSource
					copyReplaceFrom: anInteger
					to: anInteger - 1
					with: aString)
				doitFlag: false
				errorMessage: aString
				location: anInteger 
	! !

!OstCompiler methodsFor: 'private' stamp: 'StefanMarr 12/7/2011 22:26'!
parse: methodBoolean
	| methodNode transformer |
	methodNode := super parse: methodBoolean.
	
	methodBoolean ifTrue: [
		transformer := OstTransformer new.
		transformer fullTransformation: doFullTransformation.
		transformer applyTransformations: methodNode inScopeOf: class.
	].
	^ methodNode! !

!OstCompiler methodsFor: 'compiler' stamp: 'StefanMarr 12/7/2011 22:14'!
recompile: aCompiledMethod
	"Recompile the given method normally, i.e., with out full STM transformation"

	^ self recompile: aCompiledMethod omnified: false.! !

!OstCompiler methodsFor: 'compiler' stamp: 'StefanMarr 12/11/2011 16:50'!
recompile: aCompiledMethod omnified: aBool
	"Recompile the given method"

	| methodSource newSelector  newMethodNode |
	
	doFullTransformation := aBool.
	
	methodSource := aCompiledMethod getSource.
	newSelector  := aCompiledMethod selector asOmniSelector.
		
	newMethodNode := self
		compile: methodSource in: aCompiledMethod methodClass notifying: self
		ifFail: [^ self problem: 'syntax error' sel: newSelector in: aCompiledMethod methodClass].

	^ newMethodNode generate.! !

!OstCompiler methodsFor: 'compiler' stamp: 'StefanMarr 12/7/2011 22:14'!
recompileOmnified: aCompiledMethod
	"Recompile the given method with the STM enabled"

	^ self recompile: aCompiledMethod omnified: true.! !

!RBOwnedScope methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/9/2011 15:20'!
numOmniTemps
	| parentCount |
	parentCount := owner ifNil:    [0]
	                     ifNotNil: [owner numOmniTemps].
	^ (bindings keys select: [:name | name beginsWith: 'x_omni_']) size + parentCount! !

!RBOwnedScope methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/8/2011 15:19'!
theClass
	^ owner theClass! !

!OstBGRegexDNA methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGRegexDNA methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstOrderedCollection methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstOrderedCollection methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!LeafNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 5/7/2013 20:37'!
code: anIndex type: aType

	anIndex isNil 
		ifTrue: [^aType negated].
	(CodeLimits at: aType) > anIndex 
		ifTrue: [^(CodeBases at: aType) + anIndex].
	^aType * 256 + anIndex! !

!OstBGPiDigits methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGPiDigits methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGPermGeneratorRedux methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGPermGeneratorRedux methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!RBLexicalScope methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/9/2011 15:20'!
numOmniTemps
	^ (bindings keys select: [:name | name beginsWith: 'x_omni_']) size! !

!Symbol methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/11/2011 16:49'!
precedence
	"Answer the receiver's precedence, assuming it is a valid Smalltalk
	message selector or 0 otherwise.  The numbers are 1 for unary,
	2 for binary and 3 for keyword selectors."

	self isOmniSelector 
		ifTrue: [ ^ self asNormalSelector precedence ].
	self size = 0 ifTrue: [^ 0].
	self first isLetter ifFalse: [^ 2].
	self last = $: ifTrue: [^ 3].
	^ 1! !

!Boolean methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ nil! !

!Boolean methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/22/2012 02:25'!
omniDomain: aDomain
	^ nil! !

!OstBGMeteorPieceWithIsland methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMeteorPieceWithIsland methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGChameleon methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGChameleon methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstSharedQueue methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstSharedQueue methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGBody methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGBody methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGNBody methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGNBody methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!Process methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/18/2012 22:02'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!Process methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/18/2012 22:02'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGReverseComplement methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGReverseComplement methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!Float methodsFor: '*O-ST-Core' stamp: 'StefanMarr 4/27/2013 19:37'!
omniDomain
	"floats are considered immutable, we don't need a domain for them"
	<omniUnenforced>
	^ nil! !

!Float methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:15'!
omniDomain: aDomain
	"floats are considered immutable, we don't need a domain for them"
	<omniUnenforced>
	^ nil! !

!OstBenchLoops methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBenchLoops methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

OstObject subclass: #OstDomain
	instanceVariableNames: ''
	classVariableNames: 'RegReads RegWrites Registry SomeContext'
	poolDictionaries: ''
	category: 'O-ST-Core-Reflection'!

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:20'!
currentDomain
	<omniUnenforced>
	^ Processor thisProcess omniDomain! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 12/7/2011 23:08'!
domainIndexFromClass: cls
	^ cls instVarIndexFor: #omniDomain! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 12/11/2011 18:32'!
domainIndexFromObject: obj
	^ self domainIndexFromClass: obj class! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 1/30/2013 15:05'!
initializeAllOmnifiedClasses
	" self initializeAllOmnifiedClasses "
	| omnifiedClasses |
	omnifiedClasses := Metaclass allInstances select: [:c |
		(c methodDict at: #initialize ifPresent: [:init | 
			init sendsSelector: #omnifyClass:]) = true ].
	
	omnifiedClasses do: [:c | c theNonMetaClass initialize ].
	
	^ omnifiedClasses! !

!OstDomain class methodsFor: 'omni instantiation' stamp: 'StefanMarr 3/9/2012 21:56'!
initializeDomainForNewObject: obj of: class
	"We rely here currently on the getters/setters being available.
	 This is not exactly in sync with what the 'Mirrorified' reflection API for Omni actually should provide.
	 but I hope this does not have to many performance implications. :("
	obj omniDomain: self currentDomain domainForNewObjects.
! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 6/11/2013 16:55'!
initializeOST
	" OstDomain initializeOST "
	(Process hasInstVarNamed: #omniDomain) ifFalse: [
		Process addInstVarNamed: #omniDomain.
	].

	Registry := WeakIdentityKeyDictionary new.
	RegReads := IdentityDictionary new.
	RegWrites := IdentityDictionary new.! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 7/21/2012 18:21'!
makeNilADomain
	"self makeNilADomain"
	"Then copy the methods"
	((self organization listAtCategoryNamed: 'omni handlers')
	 union: (self organization listAtCategoryNamed: 'omni primitive handlers'))
	 do: [:selector |
		| method |
		method := self lookupSelector: selector.
		UndefinedObject
				compile: method getSourceFromFile
		       classified: #'*OmniST-Core-Reflection'
		       withStamp: method timeStamp
		       notifying: nil
		       logSource: true.
	].! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 12/11/2011 18:37'!
omniDomainFrom: obj
	| idx |
	idx := self domainIndexFromObject: obj.
	
	idx ~= 0 ifTrue: [
		^ obj instVarAt: idx.
	].

	^ nil! !

!OstDomain class methodsFor: 'omni compatibility' stamp: 'StefanMarr 6/5/2013 16:11'!
ownerFor: obj
	<omniUnenforced>
	| reads |
	reads := RegReads at: obj class ifAbsent: 0.
	RegReads at: obj class put: reads + 1.
	
	obj class == OstInterval ifTrue: [
		Halt now.
		SomeContext := {
		thisContext sender.
		thisContext sender sender.
		thisContext sender sender sender.
		thisContext sender sender sender sender.
		thisContext sender sender sender sender sender.
		thisContext sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender sender.
		thisContext sender sender sender sender sender sender sender sender sender sender sender.
		}].
	
	^ Registry at: obj ifAbsent: [nil]! !

!OstDomain class methodsFor: 'omni compatibility' stamp: 'StefanMarr 4/27/2013 18:54'!
ownerFor: obj put: domain
	| writes |
	writes := RegWrites at: obj class ifAbsent: 0.
	RegWrites at: obj class put: writes + 1.
	
	^ Registry at: obj put: domain! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 7/22/2012 00:40'!
setOmniDomainOn: obj of: cls to: aDomain
	| idx |
	"idx := self domainIndexFromClass: cls.
	idx > 0
		ifTrue:  [obj instVarAt: idx put: aDomain.]
		ifFalse: [obj omniDomain: aDomain]"
	obj omniDomain: aDomain.! !

!OstDomain class methodsFor: 'initialize-release' stamp: 'StefanMarr 1/9/2012 22:53'!
unload
	(self == OstDomain and: [Process hasInstVarNamed: #omniDomain]) ifTrue: [
		Process removeInstVarNamed: #omniDomain.
	].! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 7/22/2012 01:58'!
adoptObject: obj
	<omniUnenforced>
	"self class setOmniDomainOn: obj of: obj class to: self."
	obj omniDomain: self.
	^ obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:06'!
domainForNewObjects
	"#basicNew need to determine which domain a new object is supposed
	 to belong to.
	 The standard domain is self, the domain of the currently executing
	 OProcess.
	
	 If this method is overriden, make sure that you do not allocate any objects here!!!!!!"
	^ self! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 7/22/2012 01:58'!
evaluateInContext: aBlock
	<omniUnenforced>
	| oldDomain proc result |
	proc := Processor activeProcess.
	
	oldDomain := proc omniDomain.
	
	proc omniDomain: self.
	
	result := aBlock value.
	
	proc omniDomain: oldDomain.
	
	^ result! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 8/2/2012 14:50'!
evaluateInContextOnBaseLevel: aBlock
	<omniUnenforced>
	"We require in this Omni implementation
	 that the block is properly transformed
	 for an execution on the baselevel."
	^ self evaluateInContext: aBlock.! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/11/2011 20:05'!
newProcessFor: aBlock
	"Answer a Process running the code in aBlock in this domain.
	 The process is not scheduled."
	| ctx proc |
	<primitive: 19> "Simulation guard"
	ctx := [aBlock value.
			Processor terminateActive] asContext.
	proc := Process
		forContext: ctx
		priority: Processor activePriority.
	proc omniDomain: self.
	^ proc.! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:07'!
spawnHere: aBlock
	"Spawn the given block as a process in this domain"
	
	self flag: 'WARNING: copied from ODomain.
	TODO: fix later after abstracting concepts from the results of the experiments.'.
	
	^ (self newProcessFor: aBlock) resume! !

!OstObject methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstObject methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGTreeFactory methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGTreeFactory methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGTreeNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGTreeNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstDictionary methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstDictionary methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!LRSTMBenchLoops methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!LRSTMBenchLoops methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGPair methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGPair methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGMeteor methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMeteor methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstArray methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstArray methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBenchSmopstone methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBenchSmopstone methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!ATBenchLoops methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!ATBenchLoops methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGMeteorPiece methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMeteorPiece methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGFasta methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGFasta methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!SmallInteger methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ nil! !

!SmallInteger methodsFor: '*O-ST-Core' stamp: 'StefanMarr 7/22/2012 00:06'!
omniDomain: aDomain
	^ nil! !

!OstMonitor methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstMonitor methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGRandomStream methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGRandomStream methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGChameneosColour methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGChameneosColour methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGMeteorBoard methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMeteorBoard methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!Encoder methodsFor: '*O-ST-Core' stamp: 'StefanMarr 5/7/2013 20:40'!
encodeSelector: aSelector

	^self
		name: aSelector
		key: aSelector
		class: SelectorNode
		type: SendType
		set: selectorSet! !

!OstBGKNucleotide methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGKNucleotide methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!TraitBehavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/11/2011 16:49'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isOmniSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!OstRectangle methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstRectangle methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGMeetingPlace methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMeetingPlace methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstPoint methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstPoint methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGSpectralNorm methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGSpectralNorm methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGMall methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMall methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGMandelbrot methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGMandelbrot methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!SHParserST80 methodsFor: '*O-ST-Core-compatibility' stamp: 'StefanMarr 5/6/2013 23:47'!
parse: isMethodBool
	self initializeInstanceVariables.
	sourcePosition := 1.
	arguments := Dictionary new.
	temporaries := Dictionary new.
	blockDepth := bracketDepth := 0.
	ranges isNil
		ifTrue: [ranges := OrderedCollection new: 100]
		ifFalse: [ranges reset].
	errorBlock := [^ false].
	[self scanNext.
	isMethodBool
		ifTrue: [self parseMessagePattern.
			self parsePragmaSequence].
	self parseMethodTemporaries.
	isMethodBool
		ifTrue: [self parsePragmaSequence].
	self parseStatementList.
	currentToken
		ifNotNil: [self error]]
		ensure: [errorBlock := nil].
	^ true! !

!OstTestCase methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstTestCase methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstSet methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstSet methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBGChameneosRedux methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGChameneosRedux methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!TPureBehavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/8/2011 14:58'!
flushOmniMethods
	| copy |
	self methodDictionary keysDo: [ :each |
		each isOmniSelector ifTrue: [
			copy := copy ifNil: [ self methodDictionary copy ].
			copy removeDangerouslyKey: each ifAbsent: [] ] ].
	copy ifNotNil: [ self methodDictionary become: copy ]! !

!TPureBehavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/11/2011 16:44'!
selectors
	"Answer a Set of all the message selectors specified in the receiver's 
	method dictionary."

	^ self methodDict keys reject: [ :each | each isOmniSelector ]! !

!TPureBehavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/11/2011 16:44'!
selectorsAndMethodsDo: aBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysAndValuesDo: [ :selector :method |
		selector isOmniSelector 
			ifFalse: [ aBlock value: selector value: method ] ]! !

!TPureBehavior methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/11/2011 16:44'!
selectorsDo: selectorBlock
	"Evaluate selectorBlock for all the message selectors in my method dictionary."

	^ self methodDict keysDo: [ :selector |
		selector isOmniSelector 
			ifFalse: [ selectorBlock value: selector ] ]! !

!OstBGCreature methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBGCreature methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!OstBenchSlopstone methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!OstBenchSlopstone methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:14'!
omniDomain: aDomain
	<omniUnenforced>
	omniDomain := aDomain! !

!MethodNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 11/28/2011 14:36'!
generate: trailer ifQuick: methodBlock
	| v |
	(primitive = 0 and: [arguments size = 0 and: [block isQuick]])
		ifFalse: [^ self].	
	v := block code.
	v < 0
		ifTrue: [^ self].
	v = LdSelf
		ifTrue: [^ self].
	(v between: LdTrue and: LdMinus1 + 3)
		ifTrue: [^ methodBlock value: (CompiledMethod toReturnConstant: v - LdSelf trailerBytes: trailer)].
	v < ((CodeBases at: LdInstType) + (CodeLimits at: LdInstType))
		ifTrue: [^ self].
	^ self.
	! !

!RBVariableNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/4/2011 15:20'!
isInstanceBinding
	^ self variableBinding isInstanceBinding! !

!RBVariableNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/4/2011 15:27'!
isLiteralBinding
	^ self variableBinding isLiteralBinding! !

!RBVariableNode methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/4/2011 15:49'!
variableBinding: aBinding
	^ self propertyAt: #variableBinding put: aBinding! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 7/1/2013 13:08'!
baselevelPerform: aSymbol 
	<primitive: 83>
	^ self perform: aSymbol withArguments: #()! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:51'!
baselevelPerform: aSymbol with: anObject 
	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array with: anObject)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:52'!
baselevelPerform: aSymbol with: firstObject with: secondObject 
	<primitive: 83>
	^ self perform: aSymbol withArguments: (Array with: firstObject with: secondObject)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:52'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject 
	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:00'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:01'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:01'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:01'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7)! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:02'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8}! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:02'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9}! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:02'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9 with: o10
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9. o10}! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 20:49'!
baselevelPerform: selector withArguments: argArray 
	<primitive: 84>
	^ self perform: selector withArguments: argArray inSuperclass: self class! !

!Object methodsFor: '*O-ST-Core-VM-Compat' stamp: 'StefanMarr 5/1/2012 22:00'!
baselevelPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*O-ST-Core-overrides' stamp: 'StefanMarr 7/18/2012 21:57'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"
	"fixed suggested by Eliot miranda to make sure 
	
	[Object new blah + 1]
 		on: MessageNotUnderstood
 		do: [:e | e resume: 1] does not loop indefinitively"
		
	| exception resumeValue |
	
	<omniUnenforced>	
	aMessage selector isOmniSelector
		ifTrue: [
			OstCompiler omniMethod: aMessage missing: self in: aMessage lookupClass.
			
			((self respondsTo: aMessage selector) or: [
			  self isBehavior and: [self canUnderstand: aMessage selector]])
			ifTrue: [
				"And try again."
				^ aMessage sentTo: self.
			]].
		
	(exception := MessageNotUnderstood new)
				message: aMessage;
				receiver: self.
	resumeValue := exception signal.
	^exception reachedDefaultHandler
				ifTrue: [aMessage sentTo: self]
				ifFalse: [resumeValue]! !

!Object methodsFor: '*O-ST-Core' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ OstDomain ownerFor: self! !

!Object methodsFor: '*O-ST-Core' stamp: 'StefanMarr 6/5/2013 16:13'!
omniDomain: aDomain
	<omniUnenforced>
	^ OstDomain ownerFor: self put: aDomain! !

!Object methodsFor: '*O-ST-Core' stamp: 'StefanMarr 12/12/2011 16:40'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7)! !

!Object methodsFor: '*O-ST-Core' stamp: 'StefanMarr 1/8/2012 14:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8}! !

!Object methodsFor: '*O-ST-Core' stamp: 'StefanMarr 1/8/2012 14:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9}! !

!Object methodsFor: '*O-ST-Core' stamp: 'StefanMarr 1/8/2012 14:51'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: o4 with: o5 with: o6 with: o7 with: o8 with: o9 with: o10
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. o4. o5. o6. o7. o8. o9. o10}! !

Object subclass: #OstMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-ST-Core-Reflection'!

!OstMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/20/2012 15:48'!
domainOf: obj
	^ obj omniDomain! !

!OstMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/3/2013 15:45'!
reenableScheduling
	"for compatibility with VM version"! !

!OstMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/20/2012 15:49'!
setDomainOf: obj to: domain
	obj omniDomain: domain! !
